###
###
###

.seqnames <- paste("chr", c("2L", "2R", "3L", "3R", "4", "X", "U", "M", "2LHet", "2RHet", "3LHet", "3RHet", "XHet", "YHet", "Uextra"), sep="")

.circ_seqs <- "chrM"

.mseqnames <- c("upstream1000", "upstream2000", "upstream5000")

.nmask_per_seq <- 4

.onLoad <- function(libname, pkgname)
{
    extdata_dir <- system.file("extdata", package=pkgname, lib.loc=libname)
    bsgenome <- BSgenome(
        organism="Drosophila melanogaster",
        species="Fly",
        provider="UCSC",
        provider_version="dm3",
        release_date="Apr. 2006",
        release_name="BDGP Release 5",
        source_url="http://hgdownload.cse.ucsc.edu/goldenPath/dm3/bigZips/",
        seqnames=.seqnames,
        circ_seqs=.circ_seqs,
        mseqnames=.mseqnames,
        seqs_pkgname=pkgname,
        seqs_dir=extdata_dir,
        nmask_per_seq=.nmask_per_seq,
        masks_pkgname=pkgname,
        masks_dir=extdata_dir
    )

    ns <- asNamespace(pkgname)

    objname <- "BSgenome.Dmelanogaster.UCSC.dm3"
    assign(objname, bsgenome, envir=ns)
    namespaceExport(ns, objname)

    old_objname <- "Dmelanogaster"
    assign(old_objname, bsgenome, envir=ns)
    namespaceExport(ns, old_objname)
}

